<?php

namespace Drupal\ckeditor_colorbox_inline\Plugin\Filter;

use Drupal\filter\FilterProcessResult;
use Drupal\filter\Plugin\FilterBase;
use Drupal\Component\Utility\Html;

/**
 * Provides a 'CKEditor Colorbox Inline' filter.
 *
 * @Filter(
 *   id = "ckeditor_colorbox_inline",
 *   title = @Translation("CKEditor Colorbox Inline"),
 *   type = Drupal\filter\Plugin\FilterInterface::TYPE_MARKUP_LANGUAGE,
 *   weight = -10
 * )
 */
class CkeditorColorboxInline extends FilterBase {

  /**
   * {@inheritdoc}
   */
  public function process($text, $langcode) {
    $dom = Html::load($text);

    $elements = $dom->getElementsByTagName('img');
    if ($elements->length === 0) {
      return new FilterProcessResult(Html::serialize($dom));
    }

    foreach ($elements as $element) {
      $a = $dom->createElement('a');
      $element->parentNode->insertBefore($a, $element);
      $a->appendChild($element);
      $a->setAttribute('href', $element->getAttribute('src'));
      $a->setAttribute('class', 'colorbox');
    }

    return new FilterProcessResult(Html::serialize($dom));
  }

}
